package org.jw.de.muc_harlaching;

import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.Image;
import java.awt.Rectangle;
import java.util.ArrayList;
import java.util.concurrent.atomic.AtomicBoolean;
import javax.swing.Icon;
import javax.swing.ImageIcon;

/**
 * Fenster zur Statusanzeige und Steuerung
 * 
 * @author Jan
 */
public class StatusFrame extends javax.swing.JFrame {

    private final Icon ICON_ON = new ImageIcon(getClass().getResource("/org/jw/de/muc_harlaching/on.png"));
    private final Icon ICON_OFF = new ImageIcon(getClass().getResource("/org/jw/de/muc_harlaching/off.png"));
    
    private final AtomicBoolean showSignalOnPC;
    
    public StatusFrame(AtomicBoolean showSignalOnPC) {
        
        this.showSignalOnPC = showSignalOnPC;
        
        ArrayList<Image> imageList = new ArrayList<>();
        imageList.add(new ImageIcon(getClass().getResource("/org/jw/de/muc_harlaching/Bell-24.png")).getImage());
        imageList.add(new ImageIcon(getClass().getResource("/org/jw/de/muc_harlaching/Bell-32.png")).getImage());
        setIconImages(imageList);        
        
        initComponents();
        
        setConnected(false);
        updateOnOffDisplay();
    }

    void setConnected(boolean connected) {
        lbStatus.setText(connected ? "Verbunden" : "Nicht verbunden");
    }
    
    @Override
    public void setVisible(boolean visible) {
        if ( visible ) {
            GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
            GraphicsDevice defaultScreen = ge.getDefaultScreenDevice();
            Rectangle rect = defaultScreen.getDefaultConfiguration().getBounds();
            final int x = (int) rect.getMaxX() - getWidth();
            final int y = 0;
            setLocation(x-10, y+10); // +/- 10 damit Fenster nicht so in Ecke klebt
        }
        super.setVisible(visible);        
    }
    
    private void updateOnOffDisplay() {
        if ( showSignalOnPC.get() ) {
            lbOnOffTxt.setText("Ein");
            lbOnOffIcon.setIcon(ICON_ON);
        } else {
            lbOnOffTxt.setText("Aus");
            lbOnOffIcon.setIcon(ICON_OFF);
        }
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        lbStatusDescr = new javax.swing.JLabel();
        lbStatus = new javax.swing.JLabel();
        lbPC = new javax.swing.JLabel();
        lbOnOffTxt = new javax.swing.JLabel();
        lbOnOffIcon = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Klingel");
        setAlwaysOnTop(true);
        setPreferredSize(new java.awt.Dimension(300, 200));
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });
        getContentPane().setLayout(new java.awt.GridBagLayout());

        lbStatusDescr.setFont(new java.awt.Font("Segoe UI", 0, 14)); // NOI18N
        lbStatusDescr.setText("Status:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        getContentPane().add(lbStatusDescr, gridBagConstraints);

        lbStatus.setFont(new java.awt.Font("Segoe UI", 1, 14)); // NOI18N
        lbStatus.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        lbStatus.setText("jLabel1");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 10, 10);
        getContentPane().add(lbStatus, gridBagConstraints);

        lbPC.setFont(new java.awt.Font("Segoe UI", 0, 14)); // NOI18N
        lbPC.setText("Signalisierung am PC:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        getContentPane().add(lbPC, gridBagConstraints);

        lbOnOffTxt.setFont(new java.awt.Font("Segoe UI", 1, 14)); // NOI18N
        lbOnOffTxt.setText("Ein");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 10, 10);
        getContentPane().add(lbOnOffTxt, gridBagConstraints);

        lbOnOffIcon.setFont(new java.awt.Font("Segoe UI", 0, 14)); // NOI18N
        lbOnOffIcon.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/jw/de/muc_harlaching/on.png"))); // NOI18N
        lbOnOffIcon.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                lbOnOffIconMouseClicked(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 10, 50);
        getContentPane().add(lbOnOffIcon, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void lbOnOffIconMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_lbOnOffIconMouseClicked
        showSignalOnPC.set( !showSignalOnPC.get() );
        updateOnOffDisplay();
    }//GEN-LAST:event_lbOnOffIconMouseClicked

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        // Fenster minimieren statt schliessen
        setState(ICONIFIED);
    }//GEN-LAST:event_formWindowClosing

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel lbOnOffIcon;
    private javax.swing.JLabel lbOnOffTxt;
    private javax.swing.JLabel lbPC;
    private javax.swing.JLabel lbStatus;
    private javax.swing.JLabel lbStatusDescr;
    // End of variables declaration//GEN-END:variables
}
